#include <iostream>
#include <fstream>
#include <cstdlib>
#include <cstring>

using namespace std;

const int maxn = 1000001;

int n, a[maxn], vis[maxn];
int u[maxn], v[maxn], nxt[maxn], g[maxn];
int vnum;

long long dfs(int x, int h, int len)
{
    vnum++;
    long long ans = h+len;
    int i = g[x];
    while (i) {
        ans += dfs(v[i], h+1, len);
        i = nxt[i];
    }
    return ans;
}

long long calc()
{
    memset(g, 0, sizeof(g));
    memset(nxt, 0, sizeof(nxt));
    memset(vis, 0, sizeof(vis));
    int i, j;
    for (i = 1; i <= n; i++) {
        u[i] = a[i]; v[i] = i;
        nxt[i] = g[u[i]]; g[u[i]] = i;
    }

    int k = 1, k_prev = 1;
    while (!vis[k]) {
        vis[k] = 1;
        k_prev = k;
        k = a[k];
    }

    j = k;
    int len = 0;
    do {
        j = a[j];
        len++;
    } while (j != k);
    long long res = len*(long long)len;

    j = k;
    int j_prev = k_prev;
    vnum = 0;
    do {
        vnum++;
        i = g[j];
        while (i) {
            if (v[i] != j_prev) {
                res += dfs(v[i], 1, len);
            }
            i = nxt[i];
        }
        j_prev = j;
        j = a[j];
    } while (j != k);

    if (vnum != n) return -1;

    return res;
}

int main(int argc, char* argv[])
{
    ifstream fin(argv[1]);
    ifstream fout(argv[2]);
    ifstream fans(argv[3]);

    int i, j;

    fin >> n;
    for (i = 1; i <= n; i++) {
        fin >> a[i];
        if (!a[i]) a[i] = i;
    }

    long long jury_ans;
    fans >> i >> j;
    if (!fans) {cout << "jury: wrong output format" << endl; return 3;}
    if (!i && !j) {
        jury_ans = calc();
    } else {
        if (i < 1 || i > n || j < 1 || j > n) {
            cout << "jury: wrong numbers in output" << endl; return 3;
        }
        int t = a[i];
        a[i] = j;
        jury_ans = calc();
        a[i] = t;
    }

    long long ans;
    fout >> i >> j;
    if (!fout) {cout << "wrong output format" << endl; return 2;}
    if (!i && !j) {
        ans = calc();
    } else {
        if (i < 1 || i > n || j < 1 || j > n) {
            cout << "wrong numbers in output" << endl; return 2;
        }
        int t = a[i];
        a[i] = j;
        ans = calc();
        a[i] = t;
    }

    if (ans > jury_ans) {
        cout << "contestant is better (" << ans << " vs " << jury_ans << ")" << endl;
        return 3;
    } else if (jury_ans > ans) {
        cout << "jury is better (" << ans << " vs " << jury_ans << ")" << endl;
        return 1;
    }

    cout << "ok " << ans << endl;

    return 0;
}
