#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <cctype>
#include <sstream>
#include <algorithm>
#include <iomanip>
#include <set>
#include <queue>

using namespace std;

const int maxn = 1000001;

int n, a[maxn];
int u[maxn], v[maxn], nxt[maxn], g[maxn];
int vis[maxn];
int num[maxn];
long long best;
int best_i, best_j;

void dfs(int x)
{
    num[x] = 1;
    int i = g[x];
    while (i) {
        dfs(v[i]);
        num[x] += num[v[i]];
        i = nxt[i];
    }
    //cout << "num[" << x << "]" << " = " << num[x] << endl;
}

void dfs1(int x, int h, long long minus, int prev)
{
    int i = g[x];
    while (i) {
        dfs1(v[i], h+1, minus + h * (long long)(num[x] - num[v[i]]), prev);
        i = nxt[i];
    }
    if (num[x] == 1) {
        //цикл увеличился на h
        //кроме этого уменьшение для вершин нашего поддерва суммарно составило minus
        //а для самой нашей вершины величина ответа уменьшилась ещё на h
        long long plus = h*(long long)n - (minus + h);
        //cout << "dfs1: x = " << x << " minus = " << minus << " plus = " << plus << endl;
        if (plus > best) {
            best_i = prev;
            best_j = x;
            best = plus;
        }
    }
}

int main()
{
    freopen("input.txt" ,"rt", stdin); freopen("output.txt", "wt", stdout);

    int i, j;

    scanf("%d", &n);
    for (i = 1; i <= n; i++) {
        scanf("%d", &a[i]);
        if (!a[i]) a[i] = i;
         //в графе храним обратные рёбра, потому что по деревьям будем бегать вниз
        u[i] = a[i]; v[i] = i;
        nxt[i] = g[u[i]]; g[u[i]] = i;
    }

    //пробегаем в поисках цикла
    int k = 1, k_prev = 1;
    while (!vis[k]) {
        vis[k] = 1;
        k_prev = k;
        k = a[k];
    }
    //cout << "k k_prev = " << k << " " << k_prev << endl;

    best = 0;
    best_i = best_j = 0;

    //бежим по циклу и запускаем dfs во все торчащие из него деревья
    j = k;
    int j_prev = k_prev;
    do {
        i = g[j];
        while (i) {
            if (v[i] != j_prev) {
                //cout << "j j_prev v[i] = " << j << " " << j_prev << " " << v[i] << endl;
                dfs(v[i]);
                dfs1(v[i], 1, 0, j_prev);
            }
            i = nxt[i];
        }
        j_prev = j;
        j = a[j];
    } while (j != k);

    cout << best_i << " " << best_j << endl;

    fclose(stdin); fclose(stdout);
    return 0;
}
